import RDF from '@rdf-esm/data-model';
import { NQuadsStrategy } from "./nquads.mjs";
import { TemplateResult } from "./TemplateResult.mjs";
export class NTriplesStrategy extends NQuadsStrategy {
  evaluateDataset(dataset, options) {
    const singleGraph = dataset.match(null, null, null, options.graph);
    return super.evaluateDataset(singleGraph, options);
  }

  evaluateQuad(quad, options) {
    if (!options.graph.equals(quad.graph)) {
      return {
        value: '',
        prefixes: []
      };
    }

    return super.evaluateQuad(RDF.triple(quad.subject, quad.predicate, quad.object), options);
  }

}
export const ntriples = (strings, ...values) => new TemplateResult({
  strings,
  values,
  tag: ntriples,
  strategy: new NTriplesStrategy(),
  defaultOptions: {
    graph: RDF.defaultGraph(),
    sortGraphs: false
  }
});